=== debian/changelog ===
libhdf4 (4.3.0-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 09 Apr 2024 20:42:32 +0200

libhdf4 (4.3.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    (closes: #1068351)
  * Update watch file to use GitHub tags.
  * Update copyright file.
  * Drop patches applied upstream. Refresh remaining patches.
  * Refresh rename_hdf_hdfalt patch.
  * Add patch to fix FTBFS when szip is enabled.
  * Drop obsolete hdf.3 manpage rules.
  * Drop obsolete hdf4_examples rules.
  * Update symbols for 4.3.0.
  * Add manpage for hdfunpac.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 04 Apr 2024 07:29:48 +0200
